diff --git a/libgui/src/qt-interpreter-events.cc b/libgui/src/qt-interpreter-events.cc
--- a/libgui/src/qt-interpreter-events.cc
+++ b/libgui/src/qt-interpreter-events.cc
@@ -575,6 +575,22 @@ namespace octave
     emit delete_debugger_pointer_signal (QString::fromStdString (file), line);
   }
 
+  void qt_interpreter_events::notify_go_created (const graphics_object& go)
+  {
+    emit go_created (go);
+  }
+
+  void qt_interpreter_events::notify_go_updated (const graphics_object& go,
+                                                 int prop_id)
+  {
+    emit go_updated (go, prop_id);
+  }
+
+  void qt_interpreter_events::notify_go_will_delete (const graphics_object& go)
+  {
+    emit go_will_delete (go);
+  }
+
   void
   qt_interpreter_events::confirm_shutdown_octave (void)
   {
diff --git a/libgui/src/qt-interpreter-events.h b/libgui/src/qt-interpreter-events.h
--- a/libgui/src/qt-interpreter-events.h
+++ b/libgui/src/qt-interpreter-events.h
@@ -35,15 +35,22 @@
 #include <QString>
 #include <QWaitCondition>
 
+#include "event-manager.h"
+#include "graphics-handle.h"
+
 #include "dialog.h"
 #include "gui-settings.h"
 
-#include "event-manager.h"
-
 // Defined for purposes of sending QList<int> as part of signal.
 typedef QList<int> QIntList;
 
 class octave_value;
+class graphics_object;
+
+namespace QtHandles
+{
+  class qt_graphics_toolkit;
+}
 
 namespace octave
 {
@@ -178,6 +185,12 @@ namespace octave
     void update_breakpoint (bool insert, const std::string& file, int line,
                             const std::string& cond);
 
+    void notify_go_created(const graphics_object& go) override;
+
+    void notify_go_updated(const graphics_object& go, int prop_id) override;
+
+    void notify_go_will_delete(const graphics_object& go) override;
+
     void lock (void) { m_mutex.lock (); }
 
     void wait (void) { m_waitcondition.wait (&m_mutex); }
@@ -260,6 +273,12 @@ namespace octave
 
     void apply_new_settings (void);
 
+    void go_created (const graphics_object& go);
+
+    void go_updated (const graphics_object& go, int prop_id);
+
+    void go_will_delete (const graphics_object& go);
+
   private:
 
     QString gui_preference_adjust (const QString& key, const QString& value);
diff --git a/libgui/src/resource.qrc b/libgui/src/resource.qrc
--- a/libgui/src/resource.qrc
+++ b/libgui/src/resource.qrc
@@ -59,6 +59,7 @@
         <file>icons/graphic_logo_VariableEditor.png</file>
         <file>icons/fleur.png</file>
         <file>icons/hand2.png</file>
+        <file>icons/hsplitter-handle.png</file>
         <file>icons/left_side.png</file>
         <file>icons/letter_logo_FilesDockWidget.png</file>
         <file>icons/letter_logo_FileEditor.png</file>
diff --git a/libgui/src/settings-dialog.cc b/libgui/src/settings-dialog.cc
--- a/libgui/src/settings-dialog.cc
+++ b/libgui/src/settings-dialog.cc
@@ -451,6 +451,11 @@ namespace octave
     // variable editor colors
     read_varedit_colors (settings);
 
+    // property inspector
+    pi_treeAlternateRows->setChecked(settings->value(pi_tree_alternate_rows).toBool());
+    pi_tableRowHeight->setValue(settings->value(pi_table_row_height).toInt());
+    pi_tableAlternateRows->setChecked(settings->value(pi_table_alternate_rows).toBool());
+
     // shortcuts
 
     shortcut_manager& scmgr = m_octave_qobj.get_shortcut_manager ();
@@ -1069,6 +1074,11 @@ namespace octave
     settings->setValue (ve_font_size.key, varedit_fontSize->value ());
     write_varedit_colors (settings);
 
+    // Property inspector
+    settings->setValue(pi_tree_alternate_rows.key, pi_treeAlternateRows->isChecked());
+    settings->setValue(pi_table_alternate_rows.key, pi_tableAlternateRows->isChecked());
+    settings->setValue(pi_table_row_height.key, pi_tableRowHeight->value());
+
     // shortcuts
 
     settings->setValue (sc_prevent_rl_conflicts.key, cb_prevent_readline_conflicts->isChecked ());
diff --git a/libgui/src/settings-dialog.ui b/libgui/src/settings-dialog.ui
--- a/libgui/src/settings-dialog.ui
+++ b/libgui/src/settings-dialog.ui
@@ -22,8 +22,8 @@
   <property name="windowTitle">
    <string>Preferences</string>
   </property>
-  <layout class="QVBoxLayout" name="verticalLayout_2">
-   <item>
+  <layout class="QGridLayout" name="gridLayout_25">
+   <item row="0" column="0">
     <widget class="QTabWidget" name="tabWidget">
      <property name="minimumSize">
       <size>
@@ -32,7 +32,7 @@
       </size>
      </property>
      <property name="currentIndex">
-      <number>7</number>
+      <number>0</number>
      </property>
      <widget class="QWidget" name="tab_general">
       <property name="enabled">
@@ -843,7 +843,7 @@
             <x>0</x>
             <y>0</y>
             <width>1021</width>
-            <height>1529</height>
+            <height>1528</height>
            </rect>
           </property>
           <layout class="QVBoxLayout" name="verticalLayout_16">
@@ -2609,6 +2609,91 @@
        </item>
       </layout>
      </widget>
+     <widget class="QWidget" name="tab_pi">
+      <attribute name="title">
+       <string>Property Inspector</string>
+      </attribute>
+      <layout class="QGridLayout" name="gridLayout_26">
+       <item row="0" column="0">
+        <widget class="QGroupBox" name="groupBox_14">
+         <property name="title">
+          <string>Graphics objects tree</string>
+         </property>
+         <layout class="QGridLayout" name="gridLayout_6">
+          <item row="0" column="0" colspan="2">
+           <widget class="QCheckBox" name="pi_treeAlternateRows">
+            <property name="text">
+             <string>Alternate row colors</string>
+            </property>
+           </widget>
+          </item>
+         </layout>
+        </widget>
+       </item>
+       <item row="0" column="1">
+        <widget class="QGroupBox" name="groupBox_15">
+         <property name="title">
+          <string>Graphics properties table</string>
+         </property>
+         <layout class="QGridLayout" name="gridLayout_24">
+          <item row="0" column="1">
+           <widget class="QSpinBox" name="pi_tableRowHeight">
+            <property name="minimumSize">
+             <size>
+              <width>80</width>
+              <height>0</height>
+             </size>
+            </property>
+            <property name="value">
+             <number>32</number>
+            </property>
+           </widget>
+          </item>
+          <item row="1" column="0" colspan="3">
+           <widget class="QCheckBox" name="pi_tableAlternateRows">
+            <property name="text">
+             <string>Alternate row colors</string>
+            </property>
+           </widget>
+          </item>
+          <item row="0" column="0">
+           <widget class="QLabel" name="label_4">
+            <property name="text">
+             <string>Default row height</string>
+            </property>
+           </widget>
+          </item>
+         </layout>
+        </widget>
+       </item>
+       <item row="1" column="0" colspan="2">
+        <spacer name="verticalSpacer_8">
+         <property name="orientation">
+          <enum>Qt::Vertical</enum>
+         </property>
+         <property name="sizeHint" stdset="0">
+          <size>
+           <width>20</width>
+           <height>40</height>
+          </size>
+         </property>
+        </spacer>
+       </item>
+       <item row="0" column="2">
+        <spacer name="horizontalSpacer_33">
+         <property name="orientation">
+          <enum>Qt::Horizontal</enum>
+         </property>
+         <property name="sizeHint" stdset="0">
+          <size>
+           <width>40</width>
+           <height>20</height>
+          </size>
+         </property>
+        </spacer>
+       </item>
+      </layout>
+     </widget>
      <widget class="QWidget" name="tab_shortcuts">
       <attribute name="title">
        <string>Shortcuts</string>
@@ -2764,15 +2849,15 @@
                  <attribute name="headerCascadingSectionResizes">
                   <bool>false</bool>
                  </attribute>
+                 <attribute name="headerMinimumSectionSize">
+                  <number>64</number>
+                 </attribute>
                  <attribute name="headerDefaultSectionSize">
                   <number>120</number>
                  </attribute>
                  <attribute name="headerHighlightSections">
                   <bool>false</bool>
                  </attribute>
-                 <attribute name="headerMinimumSectionSize">
-                  <number>64</number>
-                 </attribute>
                  <attribute name="headerStretchLastSection">
                   <bool>true</bool>
                  </attribute>
@@ -2996,7 +3081,7 @@
      </widget>
     </widget>
    </item>
-   <item>
+   <item row="1" column="0">
     <widget class="QDialogButtonBox" name="button_box">
      <property name="standardButtons">
       <set>QDialogButtonBox::Apply|QDialogButtonBox::Cancel|QDialogButtonBox::Ok</set>
diff --git a/libgui/src/shortcut-manager.cc b/libgui/src/shortcut-manager.cc
--- a/libgui/src/shortcut-manager.cc
+++ b/libgui/src/shortcut-manager.cc
@@ -177,6 +177,7 @@ namespace octave
     init (tr ("Show Editor"), sc_main_window_show_editor);
     init (tr ("Show Documentation"), sc_main_window_show_doc);
     init (tr ("Show Variable Editor"), sc_main_window_show_variable_editor);
+    init (tr ("Show Property Inspector"), sc_main_window_show_property_inspector);
     init (tr ("Command Window"), sc_main_window_command);
     init (tr ("Command History"), sc_main_window_history);
     init (tr ("File Browser"), sc_main_window_file_browser);
@@ -184,6 +185,7 @@ namespace octave
     init (tr ("Editor"), sc_main_window_editor);
     init (tr ("Documentation"), sc_main_window_doc);
     init (tr ("Variable Editor"), sc_main_window_variable_editor);
+    init (tr ("Property Inspector"), sc_main_window_property_inspector);
     init (tr ("Previous Widget"), sc_main_window_previous_dock);
     init (tr ("Reset Default Window Layout"), sc_main_window_reset);
 
diff --git a/libinterp/corefcn/event-manager.h b/libinterp/corefcn/event-manager.h
--- a/libinterp/corefcn/event-manager.h
+++ b/libinterp/corefcn/event-manager.h
@@ -40,6 +40,7 @@
 
 class octave_value;
 class string_vector;
+class graphics_object;
 
 namespace octave
 {
@@ -244,6 +245,18 @@ namespace octave
     update_breakpoint (bool /*insert*/, const std::string& /*file*/,
                        int /*line*/, const std::string& /*cond*/)
     { }
+
+    virtual void
+    notify_go_created(const graphics_object& /*go*/)
+    { }
+
+    virtual void
+    notify_go_updated(const graphics_object& /*go*/, int /*prop_id*/)
+    { }
+
+    virtual void
+    notify_go_will_delete(const graphics_object& /*go*/)
+    { }
   };
 
   //! Provides threadsafe access to octave.
@@ -623,6 +636,24 @@ namespace octave
         instance->update_breakpoint (insert, file, line, cond);
     }
 
+    void notify_go_created (const graphics_object& go)
+    {
+      if (enabled ())
+        instance->notify_go_created(go);
+    }
+
+    void notify_go_updated (const graphics_object& go, int prop_id)
+    {
+      if (enabled ())
+        instance->notify_go_updated(go, prop_id);
+    }
+
+    void notify_go_will_delete (const graphics_object& go)
+    {
+      if (enabled ())
+        instance->notify_go_will_delete(go);
+    }
+
   private:
 
     interpreter& m_interpreter;
diff --git a/libinterp/corefcn/genprops.awk b/libinterp/corefcn/genprops.awk
--- a/libinterp/corefcn/genprops.awk
+++ b/libinterp/corefcn/genprops.awk
@@ -300,7 +300,7 @@ function emit_declarations ()
   if (class_name && ! base)
     emit_common_declarations();
 
-  printf ("public:\n\n\n  static std::set<std::string> core_property_names (void);\n\n  static std::set<std::string> readonly_property_names (void);\n\n  static bool has_core_property (const caseless_str& pname);\n\n  static bool has_readonly_property (const caseless_str& pname);\n\n  std::set<std::string> all_property_names (void) const;\n\n");
+  printf ("public:\n\n\n  static std::set<std::string> core_property_names (void);\n\n  static std::set<std::string> readonly_property_names (void);\n\n  static bool has_core_property (const caseless_str& pname);\n\n  static bool has_readonly_property (const caseless_str& pname);\n\n  virtual std::set<std::string> all_property_names (void) const;\n\n");
 
   if (! base)
     printf ("  bool has_property (const caseless_str& pname) const;\n\n");
diff --git a/libinterp/corefcn/graphics.cc b/libinterp/corefcn/graphics.cc
--- a/libinterp/corefcn/graphics.cc
+++ b/libinterp/corefcn/graphics.cc
@@ -51,6 +51,7 @@
 #include "defun.h"
 #include "display.h"
 #include "error.h"
+#include "event-manager.h"
 #include "graphics.h"
 #include "input.h"
 #include "interpreter-private.h"
@@ -1261,13 +1262,17 @@ base_property::set (const octave_value& 
 {
   if (do_set (v))
     {
+      gh_manager& gh_mgr
+        = octave::__get_gh_manager__ ("base_property::set");
+
+      octave::event_manager& ev_mgr
+        = octave::__get_event_manager__ ("base_property::set");
+
+      graphics_object go = gh_mgr.get_object (parent);
+
       // Notify graphics toolkit.
       if (id >= 0 && do_notify_toolkit)
         {
-          gh_manager& gh_mgr
-            = octave::__get_gh_manager__ ("base_property::set");
-
-          graphics_object go = gh_mgr.get_object (parent);
           if (go)
             go.update (id);
         }
@@ -1276,6 +1281,9 @@ base_property::set (const octave_value& 
       if (do_run)
         run_listeners (GCB_POSTSET);
 
+      // notify gui of the property change
+      ev_mgr.notify_go_updated(go, id);
+
       return true;
     }
 
@@ -2858,6 +2866,9 @@ gh_manager::free (const graphics_handle&
       if (p == m_handle_map.end ())
         error ("graphics_handle::free: invalid object %g", h.value ());
 
+      // Notify the event-manager
+      m_interpreter.get_event_manager ().notify_go_will_delete (p->second);
+
       base_properties& bp = p->second.get_properties ();
 
       if (! p->second.valid_object () || bp.is_beingdeleted ())
@@ -2912,6 +2923,8 @@ void
 gh_manager::renumber_figure (const graphics_handle& old_gh,
                              const graphics_handle& new_gh)
 {
+  // FIXME: do we have to notify the event manager?
+
   auto p = m_handle_map.find (old_gh);
 
   if (p == m_handle_map.end ())
@@ -2919,10 +2932,14 @@ gh_manager::renumber_figure (const graph
 
   graphics_object go = p->second;
 
+  // m_interpreter.get_event_manager().notify_go_will_delete(go);
+
   m_handle_map.erase (p);
 
   m_handle_map[new_gh] = go;
 
+  // m_interpreter.get_event_manager().notify_go_created(go);
+
   if (old_gh.value () < 0)
     m_handle_free_list.insert (std::ceil (old_gh.value ())
                                - make_handle_fraction ());
@@ -11892,6 +11909,9 @@ gh_manager::make_graphics_handle (const 
   if (notify_toolkit)
     go.initialize ();
 
+  // Notify the event manager
+  m_interpreter.get_event_manager().notify_go_created(go);
+
   return h;
 }
 
@@ -11909,6 +11929,9 @@ gh_manager::make_figure_handle (double v
   if (notify_toolkit)
     go.initialize ();
 
+  // Notify the event manager
+  m_interpreter.get_event_manager().notify_go_created(go);
+
   go.override_defaults ();
 
   return h;
diff --git a/libinterp/corefcn/graphics.in.h b/libinterp/corefcn/graphics.in.h
--- a/libinterp/corefcn/graphics.in.h
+++ b/libinterp/corefcn/graphics.in.h
@@ -60,6 +60,25 @@
 
 // ---------------------------------------------------------------------
 
+enum property_type
+{
+  PROP_INVALID,
+  PROP_ARRAY,
+  PROP_BOOL,
+  PROP_CALLBACK,
+  PROP_CHILDREN,
+  PROP_COLOR,
+  PROP_DOUBLE,
+  PROP_DOUBLE_RADIO,
+  PROP_HANDLE,
+  PROP_RADIO,
+  PROP_ROW_VECTOR,
+  PROP_STRING,
+  PROP_STRING_ARRAY,
+  PROP_TEXT_LABEL,
+  PROP_ANY,
+};
+
 class base_scaler
 {
 public:
@@ -314,6 +333,8 @@ public:
 
   virtual bool is_radio (void) const { return false; }
 
+  virtual property_type prop_type () const { return PROP_INVALID; }
+
   int get_id (void) const { return id; }
 
   void set_id (int d) { id = d; }
@@ -440,6 +461,11 @@ public:
   string_property (const string_property& p)
     : base_property (p), str (p.str) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_STRING;
+  }
+
   octave_value get (void) const
   { return octave_value (str); }
 
@@ -525,6 +551,11 @@ public:
     : base_property (p), desired_type (p.desired_type),
       separator (p.separator), str (p.str) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_STRING_ARRAY;
+  }
+
   octave_value get (void) const
   {
     if (desired_type == string_t)
@@ -737,6 +768,11 @@ public:
     return tmp.isempty ();
   }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_TEXT_LABEL;
+  }
+
   octave_value get (void) const
   {
     if (stored_type == char_t)
@@ -941,6 +977,11 @@ public:
   radio_property (const radio_property& p)
     : base_property (p), vals (p.vals), current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_RADIO;
+  }
+
   octave_value get (void) const { return octave_value (current_val); }
 
   const std::string& current_value (void) const { return current_val; }
@@ -1107,6 +1148,11 @@ public:
       color_val (p.color_val), radio_val (p.radio_val),
       current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_COLOR;
+  }
+
   octave_value get (void) const
   {
     if (current_type == color_t)
@@ -1188,6 +1234,11 @@ public:
       minval (std::pair<double, bool> (octave_NaN, true)),
       maxval (std::pair<double, bool> (octave_NaN, true)) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_DOUBLE;
+  }
+
   octave_value get (void) const { return octave_value (current_val); }
 
   double double_value (void) const { return current_val; }
@@ -1312,6 +1363,11 @@ public:
       dval (p.dval), radio_val (p.radio_val),
       current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_DOUBLE_RADIO;
+  }
+
   octave_value get (void) const
   {
     if (current_type == double_t)
@@ -1401,6 +1457,11 @@ public:
       maxval (std::pair<double, bool> (octave_NaN, true))
   { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_ARRAY;
+  }
+
   octave_value get (void) const { return data; }
 
   void add_constraint (const std::string& type)
@@ -1517,6 +1578,11 @@ public:
     add_constraint (dim_vector (0, 0));
   }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_ROW_VECTOR;
+  }
+
   void add_constraint (const std::string& type)
   {
     array_property::add_constraint (type);
@@ -1608,6 +1674,11 @@ public:
   bool_property (const bool_property& p)
     : radio_property (p) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_BOOL;
+  }
+
   bool is_on (void) const { return is ("on"); }
 
   bool_property& operator = (const octave_value& val)
@@ -1641,6 +1712,11 @@ public:
   handle_property (const handle_property& p)
     : base_property (p), current_val (p.current_val) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_HANDLE;
+  }
+
   octave_value get (void) const { return current_val.as_octave_value (); }
 
   graphics_handle handle_value (void) const { return current_val; }
@@ -1693,6 +1769,8 @@ public:
     return *this;
   }
 
+  virtual property_type prop_type () const override { return PROP_ANY; }
+
   base_property * clone (void) const { return new any_property (*this); }
 
 protected:
@@ -1730,6 +1808,11 @@ public:
     do_init_children (p.children_list);
   }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_CHILDREN;
+  }
+
   children_property& operator = (const octave_value& val)
   {
     set (val);
@@ -1909,6 +1992,11 @@ public:
   callback_property (const callback_property& p)
     : base_property (p), callback (p.callback) { }
 
+  virtual property_type prop_type () const override
+  {
+    return PROP_CALLBACK;
+  }
+
   octave_value get (void) const { return callback; }
 
   OCTINTERP_API void execute (const octave_value& data = octave_value ()) const;
@@ -1947,6 +2035,24 @@ private:
 
 // ---------------------------------------------------------------------
 
+#if 0
+
+namespace detail {
+
+template<class prop_type>
+inline prop_type& prop_cast(base_property *rep, const char *who)
+{
+  auto *p = dynamic_cast<prop_type*>(rep);
+  if (!p) {
+    throw std::logic_error(std::string(who) + ": invalid property cast");
+  }
+  return *p;
+}
+
+}
+
+#endif // 0
+
 class property
 {
 public:
@@ -2037,6 +2143,11 @@ public:
   void run_listeners (listener_mode mode = GCB_POSTSET)
   { rep->run_listeners (mode); }
 
+  property_type prop_type() const
+  {
+    return rep->prop_type();
+  }
+
   OCTINTERP_API static
   property create (const std::string& name, const graphics_handle& parent,
                    const caseless_str& type,
@@ -2045,25 +2156,180 @@ public:
   property clone (void) const
   { return property (rep->clone ()); }
 
+  const base_property& as_base_property (void) const { return *rep; }
+
+  base_property& as_base_property (void) { return *rep; }
+
 #if 0
-  const string_property& as_string_property (void) const
-  { return *(dynamic_cast<string_property *> (rep)); }
-
-  const radio_property& as_radio_property (void) const
-  { return *(dynamic_cast<radio_property *> (rep)); }
+
+  const array_property& as_array_property (void) const
+  {
+    return detail::prop_cast<const array_property> (
+        rep, "property::as_array_property");
+  }
+
+  array_property& as_array_property (void)
+  {
+    return detail::prop_cast<array_property> (rep,
+                                              "property::as_array_property");
+  }
+
+  const bool_property& as_bool_property (void) const
+  {
+    return detail::prop_cast<const bool_property> (
+        rep, "property::as_bool_property");
+  }
+
+  bool_property& as_bool_property (void)
+  {
+    return detail::prop_cast<bool_property> (rep,
+                                             "property::as_bool_property");
+  }
+
+  const callback_property& as_callback_property (void) const
+  {
+    return detail::prop_cast<const callback_property> (
+        rep, "property::as_callback_property");
+  }
+
+  callback_property& as_callback_property (void)
+  {
+    return detail::prop_cast<callback_property> (
+        rep, "property::as_callback_property");
+  }
+
+  const children_property& as_children_property (void) const
+  {
+    return detail::prop_cast<const children_property> (
+        rep, "property::as_children_property");
+  }
+
+  children_property& as_children_property (void)
+  {
+    return detail::prop_cast<children_property> (
+        rep, "property::as_children_property");
+  }
 
   const color_property& as_color_property (void) const
-  { return *(dynamic_cast<color_property *> (rep)); }
+  {
+    return detail::prop_cast<const color_property> (
+        rep, "property::as_color_property");
+  }
+
+  color_property& as_color_property (void)
+  {
+    return detail::prop_cast<color_property> (rep,
+                                              "property::as_color_property");
+  }
 
   const double_property& as_double_property (void) const
-  { return *(dynamic_cast<double_property *> (rep)); }
-
-  const bool_property& as_bool_property (void) const
-  { return *(dynamic_cast<bool_property *> (rep)); }
+  {
+    return detail::prop_cast<const double_property> (
+        rep, "property::as_double_property");
+  }
+
+  double_property& as_double_property (void)
+  {
+    return detail::prop_cast<double_property> (rep,
+                                               "property::as_double_property");
+  }
+
+  const double_radio_property& as_double_radio_property (void) const
+  {
+    return detail::prop_cast<const double_radio_property> (
+        rep, "property::as_double_radio_property");
+  }
+
+  double_radio_property& as_double_radio_property (void)
+  {
+    return detail::prop_cast<double_radio_property> (
+        rep, "property::as_double_radio_property");
+  }
 
   const handle_property& as_handle_property (void) const
-  { return *(dynamic_cast<handle_property *> (rep)); }
-#endif
+  {
+    return detail::prop_cast<const handle_property> (
+        rep, "property::as_handle_property");
+  }
+
+  handle_property& as_handle_property (void)
+  {
+    return detail::prop_cast<handle_property> (rep,
+                                               "property::as_handle_property");
+  }
+
+  const radio_property& as_radio_property (void) const
+  {
+    return detail::prop_cast<const radio_property> (
+        rep, "property::as_radio_property");
+  }
+
+  radio_property& as_radio_property (void)
+  {
+    return detail::prop_cast<radio_property> (rep,
+                                              "property::as_radio_property");
+  }
+
+  const row_vector_property& as_row_vector_property (void) const
+  {
+    return detail::prop_cast<const row_vector_property> (
+        rep, "property::as_row_vector_property");
+  }
+
+  row_vector_property& as_row_vector_property (void)
+  {
+    return detail::prop_cast<row_vector_property> (
+        rep, "property::as_row_vector_property");
+  }
+
+  const string_property& as_string_property (void) const
+  {
+    return detail::prop_cast<const string_property> (
+        rep, "property::as_string_property");
+  }
+
+  string_property& as_string_property (void)
+  {
+    return detail::prop_cast<string_property> (rep,
+                                               "property::as_string_property");
+  }
+
+  const string_array_property& as_string_array_property (void) const
+  {
+    return detail::prop_cast<const string_array_property> (
+        rep, "property::as_string_array_property");
+  }
+
+  string_array_property& as_string_array_property (void)
+  {
+    return detail::prop_cast<string_array_property> (
+        rep, "property::as_string_array_property");
+  }
+
+  const text_label_property& as_text_label_property (void) const
+  {
+    return detail::prop_cast<const text_label_property> (
+        rep, "property::as_text_label_property");
+  }
+
+  text_label_property& as_text_label_property (void)
+  {
+    return detail::prop_cast<text_label_property> (
+        rep, "property::as_text_label_property");
+  }
+
+  const any_property& as_any_property (void) const
+  {
+    return detail::prop_cast<const any_property> (rep,
+                                                  "property::as_any_property");
+  }
+
+  any_property& as_any_property (void)
+  {
+    return detail::prop_cast<any_property> (rep, "property::as_any_property");
+  }
+
+#endif // 0
 
 private:
   base_property *rep;
diff --git a/liboctave/util/oct-mutex.h b/liboctave/util/oct-mutex.h
--- a/liboctave/util/oct-mutex.h
+++ b/liboctave/util/oct-mutex.h
@@ -26,6 +26,8 @@
 #if ! defined (octave_oct_mutex_h)
 #define octave_oct_mutex_h 1
 
+#include <stdexcept>
+
 #include "octave-config.h"
 
 #include "oct-refcount.h"
@@ -145,6 +147,48 @@ namespace octave
     bool m_lock_result;
   };
 
+  // a moveable, non-copiable lock that acts like a smart pointer
+  // the type must implement lock and unlock. (it also work with plain mutex)
+  template <class T>
+  class unique_lock
+  {
+  public:
+
+    // may be holding a ref is better
+    unique_lock (T& r) : rep (r), owned (true) { rep.lock (); }
+
+    ~unique_lock ()
+    {
+      if (owned)
+        rep.unlock ();
+    }
+
+    unique_lock (const unique_lock&) = delete;
+    unique_lock& operator= (const unique_lock&) = delete;
+
+    unique_lock (unique_lock&& other) : rep (other.rep), owned (other.owned)
+    {
+      other.owned = false;
+    }
+
+    T* operator->()
+    {
+      if (!owned)
+        throw std::logic_error { "access of non-owned locked resource" };
+      return &rep;
+    }
+
+    T& operator* ()
+    {
+      if (!owned)
+        throw std::logic_error { "access of non-owned locked resource" };
+      return rep;
+    }
+
+  private:
+    T& rep;
+    bool owned;
+  };
 
   class
   OCTAVE_API
